// the format of the parameters this reads is very strict
// ie:
// parameter_wanted   = value_wanted unit
// the "=" and the unit are ignored; value_wanted must be a float
// lines beginning with values "less than" A or with a "#" are ignored


// system include files
#include <stdio.h>

// isip include files

#include <math/integral/integral.h>
#include <math/integral/integral_constants.h>

// local include files
#include "make_files.h"

// local function declarations
int comments(char *string_ptr);

// primary function
float get_parameters(char *parameter_wanted, FILE *parameter_file)
{
  char string[MAX_LINE_LENGTH], parameter_from_file[MAX_LINE_LENGTH];
  int found = 0;
  float parameter_value = 9.3;
  
  // file parameter_file should already be open
  if((parameter_file)==NULL)
    {
       fprintf(stderr, "Unknown error in parameter file.\n");
       exit(1);
    }
  // reset the file so we are pointing to the beginning
    
  rewind(parameter_file);
  while((int)fgets( string, (MAX_LINE_LENGTH +1), parameter_file) && !found)
    {
      if((!comments(string)))
	{
	  {
	    sscanf(string,"%s%*s%f%*s", parameter_from_file,&parameter_value);
	    if(!strcmp(parameter_from_file, parameter_wanted))
	      {
		found = 1;
	      }
	  }
	}
    }
  if(!found)
    {
      fprintf(stderr, "Error.  Parameter %s not found in parameter file.  ", 
	      parameter_wanted);
      fprintf(stderr, "Defaulting to value 0.0 for %s\n", parameter_wanted);
      parameter_value = 0.0;
    }
  return(parameter_value);
}


// local function code

int comments(char *test_string_ptr)
{
  return((test_string_ptr[0] == '#') || (test_string_ptr[0] <='A'));
}







