/* File: get_prompting_text.c */

/*
 * Richard Duncan
 * Institute for Signal and Information Processing
 * December 1995
 *
 * This function calculates the prompting text given the
 * orthographic_transcription
 *
 */

#include<stdio.h>
#include<string.h>

#define __MAIN_H_
#ifndef __MAIN_H_
#define __MAIN_H_
#include"main.h"
#endif

#ifndef __GET_PROMPTING_TEXT_H_
#define __GET_PROMPTING_TEXT_H_
#include "get_prompting_text.h"
#endif

int get_prompting_text(char *prompting_text,
		       char *transcription){

  char trans_tok[8][16];
  char *temp;
  int n = 1;
  int i,j;
  int acceptable;
  
  char temp_trans[64];
  

  strcpy(temp_trans, transcription);
  
  temp = strtok(temp_trans, " ");
  strcpy(trans_tok[0], temp);
  while(temp = strtok(NULL, " ")){
    strcpy(trans_tok[n], temp);
    n++;
  };
  *prompting_text = (char) NULL;
  for(i = 0; i < n; i++){
    acceptable = 0;
    for(j=0; j < NUMBER_ACCEPTABLE_WORDS; j++){
      acceptable = (acceptable ||
		    (strcmp(trans_tok[i], acceptable_words[j]) == 0));
    }
    if (!acceptable){
      if (trans_tok[i][0] == '{'){
	while(strchr(trans_tok[i], (int) '}') == NULL){
	  trans_tok[i][0] = (char)NULL;
	  i++;
	  if (i == n){
	    fprintf(stderr, transcription_error, "mouth noise");
	  }
	}
	trans_tok[i][0] = (char)NULL;
	acceptable = 1;
      } else if (trans_tok[i][0] == '['){
	for(j=0;(j < (2 * NUMBER_TRANSLATIONS)) && (!acceptable); j+=2){
	  if(!strcmp(trans_tok[i], word_trans[j])){
	    strcpy(trans_tok[i], word_trans[j+1]);
	    acceptable = 1;
	  }
	}
	if (!acceptable){
	  fprintf(stderr, transcription_error, "deviant pronunciation");
	}
      } else {
	fprintf(stderr, "Error in transcription, token = %s, exiting!\n",
		trans_tok[i]);
      }
    }
    if(trans_tok[i][0] != (char) NULL){
      if(*prompting_text == (char) NULL){
	strcpy(prompting_text, trans_tok[i]);
      } else {
	strcat(prompting_text, " ");
	strcat(prompting_text, trans_tok[i]);
      }
    }
	     
  }
  
}

