/* File: get_prompting_text.h */

/*
 * Richard Duncan
 * Institute for Signal and Information Processing
 * December 1995
 *
 * This function calculates the prompting text given the
 * orthographic_transcription
 *
 */


/*
 * This array has a list of deviant pronounciations followed by the proper
 * spellings
 *
 */

#define NUMBER_TRANSLATIONS 7

static char word_trans[NUMBER_TRANSLATIONS * 2][8] = {
  "[dei]", "rei",
  "[ich]", "ichi",
  "[rok]", "roku",
  "[doku]", "roku",
  "[dok]", "roku",
  "[shich]", "shichi",
  "[hach]", "hachi" };


/*
 * This is an array of acceptable words for a transcription
 *
 */

static char transcription_error[] = "Error in transcription, invalid %s, exiting!\n";

#define NUMBER_ACCEPTABLE_WORDS 289

static char acceptable_words[NUMBER_ACCEPTABLE_WORDS][32] = { "zero",
"san", "ni", "rei", "nana", "yon", "go", "maru", "shi", "roku", "ku",
"hachi", "shichi", "kyu", "ichi", "ha", "hyo", "a", "myu", "ga", "mo",
"cho", "be", "bo", "nyo", "kya", "pi", "gu", "sa", "ya", "pyo", "mya",
"se", "gi", "ge", "zu", "pyu", "ra", "ju", "mi", "jo", "te", "ryo",
"nya", "shi", "ho", "chu", "byu", "ne", "bi", "bya", "byo", "ka",
"po", "ro", "i", "me", "pa", "kyo", "bu", "gya", "pu", "su", "to",
"shu", "hi", "yu", "ru", "re", "no", "hyu", "na", "ku", "nu", "ji",
"ma", "e", "za", "hya", "tsu", "hu", "go", "ta", "ze", "rya", "gyo",
"kyu", "u", "de", "ja", "ri", "pya", "yo", "gyu", "wa", "he", "cha",
"ryu", "ki", "mu", "so", "sho", "ba", "zo", "ni", "da", "myo", "pe",
"sha", "chi", "ke", "do", "o", "nyu", "ko", "n", "ti", "je", "fa",
"fo", "she", "di", "fi", "che", "fe", "bi-", "oN", "jaku", "e-",
"shita", "shi-", "dai", "kesu", "ko-tai", "kyo-", "shimeru",
"suta-to", "hidari", "mae", "sutoppu", "sho-", "ushiro", "zeNshiN",
"ohu", "appu", "chu-", "ue", "dauN", "migi", "tsukeru", "akeru",
"zeNkaku", "so-nyu-", "kaigyo-", "haNkaku", "buNmatsu", "heNkaN",
"ido-", "jipe-ji", "ke-seN", "kaipe-ji", "katakana", "seNtariNgu",
"muheNkaN", "zeNpe-ji", "taNgo", "to-roku", "jikko-", "kiNto-waritsuke",
"supe-su", "tabu", "shu-ryo-", "sakujo", "aNda-raiN", "baikaku",
"wakuake", "syo-kai", "horyu-", "hurikomi", "do-zo", "mo-ichido",
"zaNdaka", "hai", "torikeshi", "owari", "hajime", "i-e", "te-se-",
"toritsugi", "hachinohe", "keseNnuma", "yukuhashi", "sapporo",
"kitami", "eniwa", "yokote", "toride", "warabi", "asahi", "tsuruga",
"takehu", "hekinaN", "yasugi", "zentsu-ji", "rumoi", "bibai",
"seNdai", "teNdo-", "naNyo-", "mo-ka", "kazo", "ni-za", "ho-ya",
"uozu", "matto-", "o-bu", "ko-be", "gobo-", "siNgu-", "kure", "mine",
"buzeN", "beppu", "nemuro", "susono", "gamago-ri", "so-ja", "chiba",
"noda", "zushi", "date", "himi", "gihu", "mutsu", "ageo", "ehime",
"hujiidera", "ibusuki", "zama", "meguro", "gushikawa", "numazu",
"rikuzeNtakada", "koganei", "yonago", "sasebo", "tochigi", "kamo",
"wako-", "bisai", "tsuru", "ube", "iyo", "nihoNmatsu", "yame",
"takeo", "hoNdo", "mito", "naha", "shiNjo-", "kiryu-", "hanyu-",
"teNryu-", "huchu-", "chiryu-", "buNkyo-", "o-muta", "yu-ki", "suzu",
"neyagawa", "eNzaN", "hisai", "muko-", "daito-", "kuroiso", "ninohe",
"goteNba", "moriguchi", "so-ka", "seki", "hoNjo-", "saNjo-", "ebina",
"masuda", "ko-hu", "bizeN", "huji", "hagi", "kiyose" };



int get_prompting_text();

