/* File: read_session_info.c */

/*
 * Richard Duncan
 * Institute for Signal and Information Processing
 * December 1995
 */

/*
 * This function reads in the fields from the session_info file into
 * the header
 *
 */

#ifndef __MAIN_H_
#define __MAIN_H_
#include "main.h"
#endif
#include<stdio.h>

#ifndef __SP_SPHERE_H_
#define __SP_SPHERE_H_
#include <sp/sphere.h>
#endif

#ifndef __READ_SESSION_INFO_H_
#define __READ_SESSION_INFO_H_
#include "read_session_info.h"
#endif

int read_session_info(struct header_t *header,
		      FILE *session_info_fp,
		      char *val_filename){
  
  char field_name[64];
  char field_value[128];
  
  rewind(session_info_fp);
  while(!feof(session_info_fp)){
    if((fscanf(session_info_fp,session_info_file_format,
	      field_name,field_value) > 0) && (*field_name != '"')){ 
      if(!strcmp(field_name,"speaker_session_number")){
	int session_number;
	session_number = atoi(strstr(val_filename, "_r")+2);
	sprintf(field_value, "%s-0%1d", field_value, session_number);
      }
      if(sp_add_field(header, field_name, T_STRING, field_value) < 0){
	fprintf(stderr, field_error, field_name);
	exit(40);
      }
    }
  }
}


