// file: /u1/picone/jeida/plot_signal/plot_signal.h
//
// this file defines constants used in plot_signal.C
//

// Make sure this file is only included once
//
#ifndef __ISIP_PLOT_SIGNAL
#define __ISIP_PLOT_SIGNAL

// important constants
//
#define ISIP_PROGRAM_NAME "plot_signal"

// define default values
//
#define DEFAULT_SAMPLE_FREQ 16000.0
#define DEFAULT_START_TIME 0.0
#define DEFAULT_END_TIME -1.0
#define DEFAULT_RESOLUTION 1024
#define DEFAULT_NUMBER_BYTES_PER_SAMPLE 2
#define DEFAULT_NUMBER_OF_CHANNELS 2
#define DEFAULT_CHANNEL_NUMBER 0
#define DEFAULT_BUFFER_SIZE 64000

// define some useful math constants
//
#define DEFAULT_LARGE_NUMBER (int_4)(ISIP_2EXP31 - 1)

// define command line identifiers
//
#define ISIP_OPT_SF "-sf"
#define ISIP_OPT_START "-start"
#define ISIP_OPT_END "-end"
#define ISIP_OPT_RES "-res"
#define ISIP_OPT_NBYTES "-num_bytes"
#define ISIP_OPT_NCHAN "-num_chan"
#define ISIP_OPT_CHAN "-channel"

// function definitions
//
logical_1 get_parameters_C(int, char**,
			   float_4&, float_4&, float_4&, int_4&,
			   int_4&, int_4&, int_4&,
			   char_1* file);

//
// end of file
#endif
