// file:  energy_2.cc
//

#include "endpointer.h"

#define FRAME_BUFFER_SIZE 10

// external function prototypes
//

float debiased_energy(short int *, int);
void histogram(float *, int, float, struct parameter_data *); 


// main function
//

void energy_2(FILE *source_file, int file_length, float *energy_array, int size_of_energy_array, struct parameter_data *parameter)
{
  
// variable declarations
//

  int samples_in_frame;
  int samples_in_window;
  int offset_1;
  int offset_2;
  int samples_to_read;
  int counter;
  int frame_number = 0;
  float max_energy = 0;
  short int *all_channels_wb, *window_buffer, *zc_buffer, *filtered_window_buffer;

// initialize some values
//

  samples_in_frame = (int)(parameter->frame_duration * parameter->sample_frequency);
  samples_in_window = (int)(parameter->window_duration * parameter->sample_frequency);
  offset_1 = (samples_in_window - samples_in_frame) / 2; 
  
//  printf("samples_in_frame = %d\n",samples_in_frame);
//  printf("samples_in_window = %d\n",samples_in_window);
//  printf("offset_1 = %d\n",offset_1);

// allocate space for arrays
//

  all_channels_wb = (short int *)malloc(SAMPLE_SIZE * samples_in_window * (int)parameter->number_of_channels);
  window_buffer = (short int *)malloc(SAMPLE_SIZE * samples_in_window);
  zc_buffer = (short int *)malloc(SAMPLE_SIZE * samples_in_window);
  filtered_window_buffer = (short int *)malloc(SAMPLE_SIZE * samples_in_window);
// initialize all_channels_wb buffer to zero's
//
  
  for(counter = 0;counter < samples_in_window * (int)parameter->number_of_channels; counter ++)
  all_channels_wb[counter] = 0;

// initially read 'offset' number of samples into all_channels_wb
//

  rewind(source_file);
  fread((all_channels_wb + offset_1 * (int)parameter->number_of_channels), offset_1 * (int)parameter->number_of_channels, SAMPLE_SIZE, source_file);

//  for(counter = 0; counter < samples_in_window * (int)parameter->number_of_channels; counter ++)
// printf("%d ",all_channels_wb[counter]);

// find offset_2 and samples_to_read
//

offset_2 = 2 * offset_1 * (int)parameter->number_of_channels;
samples_to_read = samples_in_frame * (int)parameter->number_of_channels; 
//printf("\noffset_2 = %d\n",offset_2);
//printf("samples_to_read = %d\n", samples_to_read);

// main file-reading loop
//

while (fread((all_channels_wb + offset_2), samples_to_read, SAMPLE_SIZE, source_file) > 0)
  {
//    printf("\n\n");
//    for(counter = 0; counter < samples_in_window * (int)parameter->number_of_channels; counter ++)
//      printf("%d ",all_channels_wb[counter]);
  
// grab channel of interest and place in window_buffer
//

    for(counter = 0; counter < samples_in_window; counter ++)
    	window_buffer[counter] = all_channels_wb[counter * (int)parameter->number_of_channels + (int)parameter->channel_to_be_processed];
//     printf("\n\n"); 
//   for(counter = 0; counter < samples_in_window; counter ++)
//      printf("%d ",window_buffer[counter]);

// shift window down
//
    for(counter = 0; counter < offset_2; counter ++)
      all_channels_wb[counter] = all_channels_wb[counter + samples_to_read];

// low-pass filter window_buffer
//

    for(counter = 1; counter < samples_in_window - 1; counter ++)
      filtered_window_buffer[counter] = (int)(0.577 * (float)window_buffer[counter - 1] + 0.577 * (float)window_buffer[counter] + 0.577 * (float)window_buffer[counter + 1]);

    

// calculated debiased energy
//

    energy_array[frame_number] = debiased_energy(filtered_window_buffer, samples_in_window);
//    printf("%d %5.2f\n",frame_number, *energy_array[frame_number]);

    frame_number ++;

  }

// find max energy value
//  
  counter = 0;
  while (counter < frame_number)
    {
      if (energy_array[counter] > max_energy)
	max_energy = energy_array[counter];
      counter ++;
    }
//  printf("max energy value is :%5.2f\n",max_energy);

//  normalize energy
//

  counter = 0;
  while (counter < frame_number)
    {
      energy_array[counter] -= max_energy;
//     printf("%d %5.2f\n",counter, energy_array[counter]);
      counter ++;
    }

// generate histogram
//
 
  histogram(energy_array, size_of_energy_array, max_energy, parameter);
  
  return;
}























