#!/usr/local/tk/bin/wish -f
#
# file: /isip/d00/jeida/src/validate/v1.0/src/display.tcl
#
# This program acts as the gui for the validator
#
# This is a new version of display.tcl, without using the guibuilder
#

# declare all the globals
#
global Topgeom Toppos
global val_file_name
global transcription
global old_transcription
global comments
global old_comments
global save_flag
global maxcolnum
global env
global validator_title
global p
# initialize the variables
#
set transcription ""
set comments ""

# set up the play procedure, this needs to be moved to a new file
#
proc proc_play {} {
    eval exec $audio_command 2> /dev/null
}

# withdraw the existing toplevel, to make way for new one
#
wm withdraw .


# destroy the toplevel, if neccessary
#
catch {destroy $p}

# set up the new toplevel
#
toplevel $p

# no size set for $p yet, packing will be used
#
wm title $p $validator_title


# set up the quit button
#
button $p.asdf -text "asdf" -command { exit }
button $p.quit -text "Quit Validator" -command {
    if {$save_flag != 0} {
	save_file
    }
    exit
}

# set up the audio device label
#
label $p.audio_device -text audio_device_label

# set up the raw filename label
#
label $p.raw_filename -text raw_filename_label

# set up the filename label
#
label $p.filename -text filename_label

# set up the last date label
#
label $p.last_date -text last_date_label

# set up the last validator label
#
label $p.last_validator -textvariable last_validator_label

# set up the transcription entry widget and label
#
label $p.transcription_label -text "Enter Transcription:"
entry $p.transcription -textvariable transcription

# bind a keypress in the transcription area to set the save flag
#
# bind $p.transcription <keypress> { set save_flag 1 }


# set up the comments entry widget and label
#
label $p.comments_label -text "Enter Comments:"
entry $p.comments -textvariable comments

# bind a keypress in the comments area to set the save flag
#
# bind $p.comments <keypress> { set save_flag 1 }

# set up the old transcription label widget and label
#
label $p.old_transcription_label -text "Previous Transcription:"
label $p.old_transcription -text old_transcription

# set up the old comment label widget and label
#
label $p.old_comments_label -text "Previous Comment:"
label $p.old_comments -text old_comments

# set up the Play transcription button
#
button $p.play -text "Play" -command {
    proc_play
}

# set up the Next transcription button
#
button $p.next -text "Next" -command {
    proc_file next
}

# set up the Previous transcription button
#
button $p.prev -text "Prev" -command {
    proc_file prev
}

# set up the Save transcription button
#
button $p.save -text "Save" -command save_file

# set up the Load file button
#
button $p.load_file -text "Load File" -command display_load_file

# set up the Save, Next, and Play button
#
button $p.save_next_play -text "Save, Next, Play" -command {
    save_file
    proc_file next
    proc_play
}


# set up the canvas for drawing the plot
#
canvas $p.plot

# set up the frames
#
frame $p.topleft_frame
frame $p.button_frame 
frame $p.listbox_frame
frame $p.top_frame 
frame $p.middle_frame 
frame $p.plot_frame 
frame $p.button_lower 
frame $p.button_upper
frame $p.middle_left
frame $p.middle_right

# pack the frames into $p
#

pack $p.quit -fill x
pack $p.audio_device $p.raw_filename $p.filename $p.last_date \
	$p.last_validator -anchor w
pack $p.button_frame -side top
pack $p.load_file $p.prev $p.save_next_play -side left -anchor c \
	-in $p.button_frame
pack $p.save $p.next $p.play -side left -anchor c
#pack $p.topleft_frame $p.listbox_frame -in $p.top_frame -side left 
#pack $p.quit -in $p
#pack $p.play -in $p.top_frame

# pack the top left frame
#
#pack $p.quit -in $p.topleft_frame -fill both
#pack $p.audio_device $p.raw_filename $p.filename $p.last_date \
#	$p.last_validator $p.button_frame -fill both \
#	-in $p.topleft_frame -anchor w


# pack the button frame
#
#pack $p.button_upper $p.button_lower -in $p.button_frame \
#	-side top
#pack $p.load_file $p.prev $p.save_next_play -side left \
#	-in $p.button_upper 
#pack $p.save $p.next $p.play -side left \
#	-in $p.button_lower 

# pack the middle frame
#pack $p.middle_left $p.middle_right -in $p.middle_frame -side left\
#	-fill both
#pack $p.transcription_label $p.comments_label $p.old_transcription_label \
#	$p.old_comments_label -in $p.middle_left -side top -fill both
#pack $p.transcription $p.comments $p.old_transcription $p.old_comments \
#	-in $p.middle_right -side top -fill both

#pack the canvas frame to the bottom
#
#pack $p.plot -in $p.plot_frame -fill both

# set the width for each listbox
#
set BoxWidth [expr 50 / $maxcolnum]

# pack all the listbox frames into $p.listbox
#
for {set colnum 0} {$colnum < $maxcolnum} {incr colnum} {
    frame $p.word_frame$colnum -width $BoxWidth
    #    pack $p.word_frame$colnum -in $p.listbox_frame -side left -fill y
}

# set up the multiple word listboxes
#
for {set colnum 0} {$colnum < $maxcolnum} {incr colnum} {
    listbox $p.word$colnum -background gray80 \
	    -font -*-fixed-bold-r-normal--13-*
    #    pack $p.word$colnum -in $p.word_frame$colnum -fill both
    
    # set up the bindings for each listbox
    #
    bind $p.word$colnum <Double-Button-1> {
	set word_trimming [selection get]
	set word_length [string length $word_trimming]
	incr word_length -2
	set word_trimming [string range $word_trimming 1 $word_length]
	set transcription "$transcription $word_trimming"
	set save_flag 1
    }
}




