# file: $JEIDA/src/validate/v1.0/src/query_save.tcl
#
# This procedure asks the user if they want to save changes
# in a new window
#

proc query_save {} {
    global save_flag
    global p
    global label_transcription
    global query
    global label_transcription_saved label_transcription_edited

    if {$save_flag == 1} {
	
	# set up the new toplevel
	#
	set query $p.query
	puts "attempt to quit without saving"
	
	# delete the old query toplevel, if necessary
	#
	catch {destroy $query}

	toplevel $query
	wm title $query "Discard Changes?"
	
	# set up the text message for the new window
	#
	message $query.text -text "Files have been modified, discard changes"
	
	# set up the quit button for the query window
	#
	button $query.quit -text "Yes, discard Changes" -command {
	    set save_flag 0
	    set label_transcription $label_transcription_saved
	    destroy $query
	}

	# set up the save changes button for the query window
	#
	button $query.save -text "No, Save Changes" -command {
	    catch {destroy $query}
	}

	# pack the new widgets into the window
	#
	pack $query.text -fill x
	pack $query.quit $query.save -side left -fill x -expand true
    }
}
