# file: $JEIDA/src/validate/v1.0/src/read_file.tcl
#
# This procedure reads in a validation file
#

proc read_file {} {
    global argv
    global speech_data_file
    global validation_file_extension 
    global number_of_channels 
    global sample_type 
    global channel_to_be_processed 
    global sample_frequency 
    global wordlist 
    global audio_command  
    global transcription 
    global comments 
    global old_transcription
    global utterances_in_set
    global speaker_number
    global utterance_number
    global set_number
    global transcriber 
    global transcription_date 
    global flag_file
    global internal_username
    global full_wordlist
    global current_file_pos
    global my_file
    global val_file_name
    global audio_device
    global value
    global env
    global p
    global read_word_list_flag
    global default_audio_command
    
    # read from the filelist
    #
    set f [open $argv]
    for {set i 0} {$i <= $current_file_pos} {incr i} {
	gets $f my_file
    }
    close $f
    
    set tmp_string ""
    
    # initialize old_comments and old_transcription
    #
    set old_comments ""
    set old_transcription ""
    
    # strip the pathname and extension from the filename
    #
    set val_file_name [exec basename $my_file .raw]
    set val_file_name "$val_file_name.val"
    set val_file_name "[file dirname $my_file]/$val_file_name"
    
    
    # open the file if it exists, else open the default valfile
    #
    if { [file exists $val_file_name] == 1 } { 
	set flag_file $val_file_name
    } else {
	#cp valfile to my_file.val
	set flag_file "$env(JEIDA)/src/validate/v1.0/src/valfile.default"
    }
    set the_file [open $flag_file]
    
    # read in the parameters from the file
    #
    while {[gets $the_file line] >= 0 } {
	scan $line "%s = %s" parameter value
	if { ( [string index $line 0] != "#" ) && ([string index $line 0] != " ")} {
	    if {$parameter == "sample_frequency" } {
		set $parameter $value
	    } elseif {$parameter == "wordlist" } {
		# trim extra "s from $value for full_wordlist
		#
		set tmp_wordlist  [string trim $value "\""]
		if {$tmp_wordlist != $full_wordlist} {
		    set read_word_list_flag 0
		}
		set full_wordlist $tmp_wordlist
		if {$read_word_list_flag == 0} {
		    readlist $value
		    set read_word_list_flag 1
		}
	    } elseif {$parameter == "transcription"} {
		set $parameter [string range $line [expr [string length "$parameter = "] + 1] end]

		set $parameter [string trim $transcription \"]
		set old_transcription $transcription
		$p.old_transcription configure -text $transcription
	    } elseif {$parameter == "transcription_date"} {
		set $parameter [string range $line [expr [string length "$parameter = "] + 1] end]
		set $parameter [string trim $transcription_date \"]

	    } elseif {$parameter == "audio_command"} {
		set tmp_string " "
		set $parameter [string range $line [expr [string length "$parameter = "] + 1] end]
		set $parameter [string trim $parameter \"]
		set $parameter "$default_audio_command -u $audio_device -s $sample_frequency -o mono $my_file > /dev/null"

	    } elseif {$parameter == "comments"} {
		set $parameter [string range $line [expr [string length "$parameter = "] + 1] end]
		set $parameter [string trim $comments \"]
		set old_comments $comments
		$p.old_comments configure -text $comments
	    } else {
		set $parameter $value
	    }
	}
	
	# re-initialize the temporary variables
	#
	set parameter ""
	set value ""
    }
    set wordlist ""
    
    close $the_file
    set transcription $old_transcription
    set comments $old_comments

    # if the transcription is <none> clear it and comments
    #
    if {[string trim $transcription] == "<none>"} {
	set comments ""
	set transcription ""
    }
}



    
    
