# file $JEIDA/src/validate/v1.0/src/save_file.tcl
#
# This procedure saves a validation file
#

proc save_file {} {
    global val_file_name
    global speech_data_file
    global validation_file_extension
    global number_of_channels
    global channel_to_be_processed
    global sample_frequency
    global wordlist
    global audio_command
    global transcription
    global env
    global comments
    global transcriber
    global transcription_date
    global flag_file
    global my_file
    global full_wordlist
    global old_transcription
    global old_comments
    global save_flag
    global label_transcription
    global label_transcription_saved label_transcription_edited
    global utterances_in_set
    global speaker_number
    global output_directory
    global utterance_number
    global set_number
    global out_file_format
    
    set counter 0
    set extender "_"

    if {$save_flag == 1} {
	# restore filename for saving, in case it is valfile.default
	
	# interpret the new validation file name
	#
	set val_file_name [exec basename $my_file .raw]
	set val_file_name "$val_file_name.val"
	set val_file_name "[file dirname $my_file]/$val_file_name"

	# create a new validation file name
	#
	if { [file exists $val_file_name] == 1} {
	    set test_file_name "$val_file_name$extender$counter"
	    while { [file exists $test_file_name] == 1} {
		incr counter +1
		set test_file_name "$val_file_name$extender$counter"
	    }
	    exec cp $val_file_name $test_file_name
	    exec rm $val_file_name
	}
	
	# get current data
	#
	
	set transcription_date [exec date]
	set transcriber $env(LOGNAME)
	
	# open file for output, write all data, and close the file
	#
	
	set output_file [open $val_file_name w]
	
	puts $output_file "speech_data_file = $my_file"
	puts $output_file "validation_file_extension = $validation_file_extension"
	puts $output_file "number_of_channels = $number_of_channels"
	puts $output_file "channel_to_be_processed = $channel_to_be_processed"
	puts $output_file "sample_frequency = $sample_frequency"
	puts $output_file "wordlist = \"$full_wordlist\""
	puts $output_file "audio_command = \"$audio_command\""
	puts $output_file "transcription = \"$transcription\""
	puts $output_file "comments = \"$comments\""
	puts $output_file "transcriber = \"$transcriber\""
	puts $output_file "transcription_date = \"$transcription_date\""
	close $output_file
	
	# reupdate the display
	#
	update_window
	
	# set the save flag and the visible astrick
	#
	set save_flag 0
	set label_transcription $label_transcription_saved
    }
}







