# file: $JEIDA/src/validate/v1.0/src/proc_file.tcl
#
# This procedure handles next-file/ previous-file requests
#

proc proc_file {direction}  {
    global max_files
    global current_file_pos
    global value
    global transcription
    global comments
    global save_flag
    global utterances_in_set
    global repetitions_in_session
    global utterance_number
    global repetition_number
    global output_directory
    global speaker_sex
    global speaker_number
    global garbage_transcription
    global needs_review_transcription

    # save the current file
    #
    save_file
    
    # incremement the file position pointer the appropriate way
    #
    if {$direction == "next" } {
	incr current_file_pos 1
	if { $current_file_pos > $max_files } {
	    
	    # reset if necessary
	    #
	    set current_file_pos 0
	}
	if { ($transcription != $garbage_transcription) && \
		($transcription != $needs_review_transcription) } {
	    incr utterance_number 1
	    if {$utterance_number > $utterances_in_set} {
		set utterance_number 1
		incr repetition_number 1
		if {$repetition_number > $repetitions_in_session} {
		    set repetition_number 1
		    incr speaker_number
		    set speaker_string [format "%s%4d" $speaker_sex \
			    $speaker_number]
		    regsub -all "\ " $speaker_string "0" speaker_string
		    set output_directory [string trimright $output_directory /]
		    set output_directory \
			    "[file dirname $output_directory]/$speaker_string"
		    if {[file exists $output_directory] != 1} {
			exec mkdir $output_directory
		    }
		}
	    }
	}
    } else {
	if {$current_file_pos == 0} {
	    
	    # reset if necessary
	    #
	    set current_file_pos $max_files
	} else {
	    incr current_file_pos -1
	}
	if { ($transcription != $garbage_transcription) && \
		($transcription != $needs_review_transcription) } {
	    incr utterance_number -1
	    if {$utterance_number == 0 } {
		set utterance_number $utterances_in_set
		incr repetition_number -1
		if {$repetition_number == 0 } {
		    set repetition_number $repetitions_in_session
		    incr speaker_number -1
		    set speaker_string [format "%s%4d" $speaker_sex \
			    $speaker_number]
		    regsub -all "\ " $speaker_string "0" speaker_string
		    set output_directory [string trimright $output_directory /]
		    set output_directory \
			    "[file dirname $output_directory]/$speaker_string"
		    if {[file exists $output_directory] != 1} {
			exec mkdir $output_directory
		    }

		}
	    }
	}
    }
    
    # read in the file  
    # 
    read_file
}





